#include "CppLine.h"

const string CppLine::AllowedWordChar(
   "abcdefghijklmnopqrstuvwxyz_ABCDEFGHIJKLMNOPQRSTUVWXYZ");
const string CppLine::AllowedWordDigitChar(
   "abcdefghijklmnopqrstuvwxyz_0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ");

   // Konstruktor
CppLine::CppLine
   (
   const string & init_str
   ):
   mc_codeLine (init_str),
   mc_indexNextPossWordStart(0)
{
}



string& 
CppLine::GetNxtWord
   (
   string & arc_word
   )
{
// Anfang des naechsten Wortes suchen.
mc_indexNextPossWordStart = mc_codeLine. find_first_of(
       CppLine::AllowedWordChar, mc_indexNextPossWordStart);
if (mc_indexNextPossWordStart == string::npos)
   {
   // Es gibt kein weiteres Wort in mc_codeLine
   arc_word = "";
   } // if (mc_indexNextPossWordStart  == string::npos)

else
   {
   string::size_type start = mc_indexNextPossWordStart;
   // Ende des Wortes ab mc_indexNextPossWordStart finden
   mc_indexNextPossWordStart = mc_codeLine. find_first_not_of(
             CppLine::AllowedWordDigitChar, mc_indexNextPossWordStart);
   if (mc_indexNextPossWordStart == string::npos)
      {
      // Rueckgabe des Strings von start bis zum Ende
      arc_word = mc_codeLine. substr(start);
      }
   else
      {
      // mc_codeLine enthaalt noch mehr als ein Wort
      arc_word = mc_codeLine. substr(start,
          mc_indexNextPossWordStart - start);
      ++mc_indexNextPossWordStart;
      }
   } // else von if (mc_indexNextPossWordStart  == string::npos)

return arc_word;
}


void
CppLine::Write
   (
   ostream & arc_str
   ) const
{
arc_str << mc_codeLine;
}


ostream& operator<<(ostream & arc_str, const CppLine & arc_line)
{
arc_line. Write(arc_str);
return arc_str;
}



