#include <string>
#include <iostream>
using namespace std;


class CppLine
{
public:
   // Konstruktor
   CppLine(const string & init_str);

   // arc_word wird auch zurueckgegeben
   string& GetNxtWord(string & arc_word);
   void Write(ostream & arc_str) const;


private:
   // Elemente

   // Zur Speicherung des im Konstruktor bergebenen Strings
   string mc_codeLine;
   // Index auf die Stelle in mc_codeLine, an der das nchste Cpp-
   //   Wort beginnen knnte.
   string::size_type mc_indexNextPossWordStart;

   // enthaelt alle Zeichen, die in einem C++-Bezeichner
   // vorkommen duerfen
   static const string AllowedWordChar;
   static const string AllowedWordDigitChar;

   // friend zwar nicht erforderlich, aber wenn dann mit dieser 
   // Syntax bzgl. std...
   friend ostream& operator<<(ostream & arc_str, const CppLine & arc_line);
};


ostream& operator<<(ostream & arc_str, const CppLine & arc_line);
